diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/core/test/random-variable-stream-test-suite.cc ns-3.33/src/core/test/random-variable-stream-test-suite.cc
--- ns-3.32/src/core/test/random-variable-stream-test-suite.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/core/test/random-variable-stream-test-suite.cc	2021-01-09 10:19:22.000000000 -0800
@@ -2403,6 +2403,38 @@
 }
 
 /**
+ * Test case for caching of Normal RV parameters (see issue #302)
+ */
+class NormalCachingTestCase : public TestCaseBase
+{
+public:
+  // Constructor
+  NormalCachingTestCase ();
+
+private:
+  // Inherited
+  virtual void DoRun (void);
+};
+
+NormalCachingTestCase::NormalCachingTestCase ()
+  : TestCaseBase ("NormalRandomVariable caching of parameters")
+{}
+
+void
+NormalCachingTestCase::DoRun (void)
+{
+  NS_LOG_FUNCTION (this);
+  SetTestSuiteSeed ();
+
+  Ptr<NormalRandomVariable> n = CreateObject<NormalRandomVariable> ();
+  double v1 = n->GetValue (-10, 1, 10);  // Mean -10, variance 1, bounded to [-20,0]
+  double v2 = n->GetValue (10, 1, 10);   // Mean 10, variance 1, bounded to [0,20]
+
+  NS_TEST_ASSERT_MSG_LT (v1, 0, "Incorrect value returned, expected < 0");
+  NS_TEST_ASSERT_MSG_GT (v2, 0, "Incorrect value returned, expected > 0");
+}
+
+/**
  * RandomVariableStream test suite, covering all random number variable
  * stream generator types.
  */ 
@@ -2451,6 +2483,8 @@
   AddTestCase (new DeterministicTestCase);
   AddTestCase (new EmpiricalTestCase);
   AddTestCase (new EmpiricalAntitheticTestCase);
+  /// Issue #302:  NormalRandomVariable produces stale values
+  AddTestCase (new NormalCachingTestCase);
 }
 
 static RandomVariableSuite randomVariableSuite;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/core/test/time-test-suite.cc ns-3.33/src/core/test/time-test-suite.cc
--- ns-3.32/src/core/test/time-test-suite.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/core/test/time-test-suite.cc	2021-01-09 10:19:22.000000000 -0800
@@ -419,10 +419,17 @@
    */ 
   virtual void DoRun (void);
   /**
-   * \brief Check test case.
+   * \brief Check roundtrip from/to string.
    * \param str Time input check.
    */
   void Check (const std::string & str);
+
+  /**
+   * \brief Check autoscaling output using Time::As()
+   * \param t Time instance.
+   * \param expect Expected string output with Time::As() autoscaling.
+   */
+  void CheckAs (const Time t, const std::string expect);
 };
 
 TimeInputOutputTestCase::TimeInputOutputTestCase ()
@@ -438,7 +445,7 @@
   ss << time;
   bool pass = (str == ss.str ());
 
-  std::cout << GetParent ()->GetName () << " InputOutput: "
+  std::cout << GetParent ()->GetName () << " InputOutput:    "
             << (pass ? "pass " : "FAIL ")
             << "\"" << str << "\"";
   if (!pass)
@@ -446,6 +453,28 @@
       std::cout << ", got " << ss.str ();
     }
   std::cout << std::endl;
+  NS_TEST_EXPECT_MSG_EQ (ss.str (), str, "round trip conversion from/to string");
+}
+
+void
+TimeInputOutputTestCase::CheckAs (const Time t, const std::string expect)
+{
+  std::stringstream ss;
+  ss << std::fixed << std::setprecision (6) << t.As ();
+  std::string str;
+  ss >> str;
+  bool pass = (str == expect);
+
+  std::cout << GetParent ()->GetName () << " InputOutput:As: "
+            << (pass ? "pass " : "FAIL ")
+            << "\"" << expect << "\"";
+  if (!pass)
+    {
+      std::cout << ", got " << str;
+    }
+  std::cout << std::endl;
+  NS_TEST_EXPECT_MSG_EQ (str, expect, "Time::As() autoscaling");
+
 }
 
 void
@@ -484,7 +513,26 @@
             << "example: Get ns: " << t.GetNanoSeconds ()
             << std::endl;
 
-  std::cout << std::endl;
+  std::cout << GetParent ()->GetName () << " InputOutput: "
+            << "example: auto scale: \n";
+  CheckAs (t * 1e-9, "+3.000000ns");
+  CheckAs (t * 1e-8, "+31.000000ns");
+  CheckAs (t * 1e-7, "+314.000000ns");
+  CheckAs (t * 1e-6, "+3.142000us");
+  CheckAs (t * 1e-5, "+31.416000us");
+  CheckAs (t * 1e-4, "+314.159000us");
+  CheckAs (t * 1e-3, "+3.141593ms");
+  CheckAs (t * 1e-2, "+31.415927ms");
+  CheckAs (t * 1e-1, "+314.159265ms");
+  CheckAs (t * 1e-0, "+3.141593s");
+  CheckAs (t * 1e+1, "+31.415927s");
+  CheckAs (t * 1e+2, "+5.235988min");
+  CheckAs (t * 1e+3, "+52.359878min");
+  CheckAs (t * 1e+4, "+8.726646h");
+  CheckAs (t * 1e+5, "+3.636103d");
+  CheckAs (t * 1e+6, "+36.361026d");
+  CheckAs (t * 1e+7, "+363.610261d");
+  CheckAs (t * 1e+8, "+9.961925y");
 }
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/core/wscript ns-3.33/src/core/wscript
--- ns-3.32/src/core/wscript	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/core/wscript	2021-01-09 10:19:22.000000000 -0800
@@ -166,6 +166,28 @@
     else:
         conf.env['ENABLE_BUILD_VERSION'] = False 
 
+    # Check for boost::units
+    if 'INCLUDES_BOOST' in conf.env:
+        fragment = r"""
+#include <boost/units/systems/si.hpp>
+int main ()
+{
+    auto q = 2 * boost::units::si::meter;
+    q.value ();
+}
+""" 
+        test_env = conf.env.derive()
+        test_env.append_value('INCLUDES', conf.env['INCLUDES_BOOST'])
+
+        ret = conf.check_nonfatal(compiler='cxx',
+                            define_name='HAVE_BOOST_UNITS',
+                            header_name='boost/units/systems/si.hpp',
+                            env=test_env,
+                            fragment=fragment,
+                            errmsg='not found')
+
+        conf.env.append_value ('CPPFLAGS', '-DHAVE_BOOST_UNITS')
+
     conf.write_config_header('ns3/core-config.h', top=True)
 
 def build(bld):
@@ -235,6 +257,8 @@
         'model/time-printer.cc',
         'model/show-progress.cc',
         'model/system-wall-clock-timestamp.cc',
+        'helper/csv-reader.cc',
+        'model/length.cc',
         ]
 
     if (bld.env['ENABLE_EXAMPLES']):
@@ -266,6 +290,7 @@
         'test/watchdog-test-suite.cc',
         'test/hash-test-suite.cc',
         'test/type-id-test-suite.cc',
+        'test/length-test-suite.cc',
         ]
 
     if (bld.env['ENABLE_EXAMPLES']):
@@ -368,6 +393,8 @@
         'model/node-printer.h',
         'model/time-printer.h',
         'model/show-progress.h',
+        'helper/csv-reader.h',
+        'model/length.h'
         ]
 
     if (bld.env['ENABLE_EXAMPLES']):
